#!/sbin/sh
#
# NativeSD FAT32 Scanner v1.0
# Author: tytung - xda-developers

# Get $HOME=/sdcard/NativeSD/Backup
HOME=`cat '/tmp/aroma/backup_home.prop' | sed 's/HOME=//g'`
if [ ! -d "$HOME" ]; then
	mkdir -p "$HOME"
fi

# Get $TEMP=/tmp/NativeSD
TEMP=`cat '/tmp/aroma/my_temp_dir.prop' | sed 's/TEMP=//g'`
if [ ! -d "$TEMP" ]; then
	mkdir -p "$TEMP"
fi

# Get $PROP_NAME=ROMsFAT32.prop
PROP_NAME=$1
if [ "$PROP_NAME" = "" ]; then
	echo PROP_NAME: not found.
	exit 0
fi

ROM_PROP_FILE="$TEMP/$PROP_NAME"
if [ -f "$ROM_PROP_FILE" ]; then
	rm "$ROM_PROP_FILE"
fi

# FAT32 Dirs
FAT32DIRS=`ls -l $HOME | egrep '^d' | awk '{print $9}'`
NUM=1

for ROM_NAME in $FAT32DIRS
do
	echo ROM_$NUM=$ROM_NAME >> "$ROM_PROP_FILE"
	NUM=$(( $NUM + 1 ))

	if [ ! -d "$TEMP/$ROM_NAME" ]; then
		mkdir -p "$TEMP/$ROM_NAME"
	fi
	BACKUP_PROP_FILE="$TEMP/$ROM_NAME/backups.prop"
	if [ -f "$BACKUP_PROP_FILE" ]; then
		rm "$BACKUP_PROP_FILE"
	fi

	BACKUP_DIRS=`ls -lr $HOME/$ROM_NAME | egrep '^d' | awk '{print $9}'`
	BACKUP_NUM=1

	for BACKUP_NAME in $BACKUP_DIRS
	do
		echo Backup_$BACKUP_NUM=$BACKUP_NAME >> "$BACKUP_PROP_FILE"
		BACKUP_NUM=$(( $BACKUP_NUM + 1 ))

		if [ ! -d "$TEMP/$ROM_NAME/$BACKUP_NAME" ]; then
			mkdir -p "$TEMP/$ROM_NAME/$BACKUP_NAME"
		fi
		TAR_PROP_FILE="$TEMP/$ROM_NAME/$BACKUP_NAME/tar.prop"
		if [ -f "$TAR_PROP_FILE" ]; then
			rm "$TAR_PROP_FILE"
		fi

		TAR_BOOT=`ls $HOME/$ROM_NAME/$BACKUP_NAME | grep 'boot'`
		if [ "$TAR_BOOT" != "" ]; then
			echo "boot=yes" >> "$TAR_PROP_FILE"
		fi
		TAR_SYSTEM=`ls $HOME/$ROM_NAME/$BACKUP_NAME | grep 'system'`
		if [ "$TAR_SYSTEM" != "" ]; then
			echo "system=yes" >> "$TAR_PROP_FILE"
		fi
		TAR_DATA=`ls $HOME/$ROM_NAME/$BACKUP_NAME | grep 'data'`
		if [ "$TAR_DATA" != "" ]; then
			echo "data=yes" >> "$TAR_PROP_FILE"
		fi
	done
done

# An example of ROMsFAT32.prop:
# 
# ROM_1=NexusHD2-ICS
# ROM_2=NexusHD2-JellyBean

# An example of backups.prop:
#
# Backup_1=2012-10-21.13.04.25_NexusHD2-JellyBean
# Backup_2=2012-10-21.15.06.32_NexusHD2-JellyBean

exit 0
