#!/sbin/sh
#
# NativeSD Backup Script v1.0
# Author: tytung - xda-developers

TYPE=$1
if [ "$TYPE" = "" ]; then
	echo Please specify Backup Type: boot, system or data.
	exit 0
fi

# Get $HOME=/sdcard/NativeSD/Backup
HOME=`cat '/tmp/aroma/backup_home.prop' | sed 's/HOME=//g'`

# Get the chosen ROM NAME
ROM_NAME=`cat '/tmp/aroma/target_rom_name.prop' | sed 's/rom_name=//g'`

# Set the backup date
if [ ! -f "/tmp/aroma/backup_date.txt" ]; then
	echo `date +%Y-%m-%d.%H.%M.%S` > "/tmp/aroma/backup_date.txt"
fi
MYDATE=`cat "/tmp/aroma/backup_date.txt"`

# Create a backup folder on the SD card
OUT_DIR="$HOME/$ROM_NAME/$MYDATE-$ROM_NAME"
mkdir -p "$OUT_DIR"

if [ "$TYPE" = "boot" ]; then

	# Enter FAT32 partition
	BOOT_DIR="$HOME/../$ROM_NAME"
	if [ -d "$BOOT_DIR" ]; then
		cd "$BOOT_DIR"

		# Backup
		tar -cvf "$OUT_DIR/$TYPE.vfat.tar" zImage initrd.gz
	else
		echo BOOT_DIR: not found. Is it a broken installation?
	fi

else # system and data

	# Enter SD-EXT partition
	cd "/NativeSD/$ROM_NAME"

	# Backup
	tar -cvf "$OUT_DIR/$TYPE.ext4.tar" $TYPE

fi
