#!/sbin/sh
#
# NativeSD MD5 Checksums Script v1.0
# Author: tytung - xda-developers

MODE=$1
if [ "$MODE" = "" ]; then
	echo Please specify Type: calculate or check.
	exit 0
fi

# Get $HOME=/sdcard/NativeSD/Backup
HOME=`cat '/tmp/aroma/backup_home.prop' | sed 's/HOME=//g'`

# Get the chosen ROM NAME
ROM_NAME=`cat '/tmp/aroma/target_rom_name.prop' | sed 's/rom_name=//g'`

MD5_NAME="nsdroid.md5"

if [ "$MODE" = "calculate" ]; then

	# Get the backup date
	MYDATE=`cat "/tmp/aroma/backup_date.txt"`

	# Get the backup folder path on the SD card
	OUT_DIR="$HOME/$ROM_NAME/$MYDATE-$ROM_NAME"
	cd "$OUT_DIR"

	md5sum * .* > "/tmp/$MD5_NAME"
	cp "/tmp/$MD5_NAME" "$OUT_DIR/$MD5_NAME"
	cat "/tmp/$MD5_NAME"

	rm "/tmp/aroma/backup_date.txt"

fi

if [ "$MODE" = "check" ]; then

	TYPE=$2
	if [ "$TYPE" = "" ]; then
		echo Please specify Type: boot, system or data.
		exit 0
	fi

	# Get the target restore folder name
	RESTORE_NAME=`cat '/tmp/aroma/target_restore_name.prop' | sed 's/restore_name=//g'`

	# Get the target restore folder path on the SD card
	RESTORE_DIR="$HOME/$ROM_NAME/$RESTORE_NAME"
	cd "$RESTORE_DIR"

	cat $MD5_NAME | grep $TYPE > "/tmp/aroma/md5sum.txt"
	md5sum -c "/tmp/aroma/md5sum.txt"
	# `echo $?` will return 0 if 'md5sum -c FILE' is executed successfully
	if [ `echo $?` != 0 ]; then
		echo "status=mismatch" > "/tmp/aroma/md5sum_check.prop"
	fi

fi
